#include "../include/mpi.h"

extern _MPI_pendings *_MPI_GetP( );
extern void _MPI_FreeP( );

/*@
  MPI_child - Get information about the children of a specified group

  Input Parameters:
. gid - process group id
. maxlis - size of clist

  Output Parameter:
. clist - array containing process group id

  Returns:
  Number of children in the group, or -1 on error.
@*/
int MPI_child( gid, maxlis, clist )
int gid, maxlis, *clist;
{
MPI_errno = 0;

return 0;
}

/*@
  MPI_copyg - Create a root group from an existing group

  Input Parameter:
. gid - process group id

  Returns:
  The gid of the new root group, or -1 on error.
@*/
int MPI_copyg( gid )
int gid;
{
MPI_errno = 12;
return -1;
}

/*@
  MPI_defrg - Define a root group

  Input Parameters:
. nprocs - number of processes in the group
. plist  - array of PID that are members of the group

  Returns:
  The gid of the new root group, or -1 on error.
@*/
int MPI_defrg( nprocs, plist )
int nprocs, *plist;
{
MPI_errno = 12;
return -1;
}

/*@
  MPI_freed - Discard the descendants of a specified group

  Input Parameter:
. gid - group id 

  Returns:
  0 on success, or -1 on error.
@*/
int MPI_freed( gid )
int gid;
{
MPI_errno = 0;
return 0;
}

/*@
  MPI_freeg - Discard a specified group and all of its descendents

  Input Parameter:
. gid - group id 

  Returns:
  0 on success, or -1 on error.
@*/
int MPI_freeg( gid )
int gid;
{
MPI_errno = 13;
return -1;
}

/*@
  MPI_partg - Partition a group into subgroups

  Input Parameters:
.  gid - group to be partitioned
.  key - key whose value determines the partitioning

  Returns:
  The gid of the subgroup to which the calling process belongs, otherwise
  -1.
@*/
int MPI_partg( gid, key )
int gid, key;
{
MPI_errno = 12;
return -1;
}

/*@
  MPI_parent - Determine the group id number of the parent of a specified 
  group

  Input Parameter:
. gid - group whose parent is to be found

  Returns:
  The group id of the parent, or -1 on error.
@*/
int MPI_parent( gid )
int gid;
{
MPI_errno = 0;
return 0;
}

/*@
  MPI_popg - Reestablish the process group context

  Returns:
  The process group id that is reestablished as the root, otherwise -1.
@*/
int MPI_popg()
{
MPI_errno = 2;
return -1;
}

/*@
  MPI_pushg - Establish the process group context

  Input Parameter:
. gid - The group context to establish

  Returns:
  The number of processes in the group gid, or -1 on error.
@*/
int MPI_pushg( gid )
int gid;
{
MPI_errno = 2;
return -1;
}

/*@
  MPI_rootg - Get information about root groups

  Input Parameter:
. maxlis - size of rlist

  Output Parameter:
. rlist - array of the process group id numbers

  Returns:
  Number of defined root groups, or -1 on error.
@*/
int MPI_rootg( maxlis, rlist )
int maxlis, *rlist;
{
MPI_errno = 0;

if (maxlis > 0)
    rlist[0] = 0;

return 1;
}

/*@
  MPI_siblg - Get information about the siblings of a group

  Input Parameters:
. gid - process group id
. maxlis - size of slist

  Output Parameter:
. slist - array of the process group ids

  Returns:
  Number of siblings, or -1 on error.
@*/
int MPI_siblg( gid, maxlis, slist )
int gid, maxlis, slist;
{
MPI_errno = 0;
return 0;
}





