#include "../include/mpi.h"

int           MPI_errno;
ASYNCSendId_t _mpi_sid;
ASYNCRecvId_t _mpi_rid;

#ifdef FORTRANUNDERSCORE
#define mpi_stopall mpi_stopall_
#define mpi_cbsend  mpi_cbsend_
#define mpi_cnsend  mpi_cnsend_
#define mpi_cbrecv  mpi_cbrecv_
#define mpi_cnrecv  mpi_cnrecv_
#define mpi_infog   mpi_infog_
#define mpi_infos   mpi_infos_
#define mpi_getid   mpi_getid_
#endif

void mpi_stopall( rc )
{
    SYexitall( (char *)0, rc );
}

int mpi_cbsend( buf, dest, type, len )
void *buf;
int  *dest, *type, *len;
{
SENDSYNCNOMEM(*type,buf,*len,*dest,MSG_OTHER);
return *len;
}

int mpi_cnsend( buf, dest, type, len )
void *buf;
int  *dest, *type, *len;
{
SENDASYNCNOMEM(*type,buf,*len,*dest,MSG_OTHER,_mpi_sid);
return (int)_mpi_sid;
}

int mpi_cbrecv( buf, source, type, maxlen )
void *buf;
int  *source, *type, *maxlen;
{
RECVSYNCNOMEM(*type,buf,*maxlen,MSG_OTHER);
return RECVLEN();
}

int mpi_cnrecv( buf, source, type, maxlen )
void *buf;
int  *source, *type, *maxlen;
{
ASYNCRecvId_t rid;
RECVASYNCNOMEM(*type,buf,*maxlen,MSG_OTHER,rid);
return (int)rid;
}

/* Still need to insure that only maxlis members are set */
int mpi_infog(gid,maxlis,plist) 
int *gid, *maxlis, *plist;
{
    if (*maxlis >= PSNUMNODES((ProcSet *)gid)) {
	PSPROCLIST((ProcSet *)*gid,plist);
	}
    return PSNUMNODES((ProcSet *)*gid);
}

int mpi_infos()
{
return RECVFROM();
}

int mpi_getid( gid )
int *gid;
{
return PSMYPROCID((ProcSet *)*gid);
}
